use strict;
package MT::Plugin::AutoUpdateAuthoredOn;

use vars qw( $VERSION );
$VERSION = '1.00';

require MT::Plugin;
require MT;
my $plugin = MT::Plugin->new({
	name => "AutoUpdateAuthoredOn",
	description => 'Automatically update the Authored On timestamp of an entry.',
	author_name => 'Yusuke Noda',
	author_link => 'http://www.ftp-recordings.net/',
	version => $VERSION
});
MT->add_plugin($plugin);

MT->add_callback('bigpapi::template::edit_entry', 9, $plugin, \&_template);

sub _template {
	my ($cb, $app, $template) = @_;
	my $old = qq{<input name="created_on_manual" id="created_on_manual" tabindex="8" value="<TMPL_VAR NAME=CREATED_ON_FORMATTED ESCAPE=HTML>" />};
	$old = quotemeta($old);
	my $new = <<"HTML";
<input name="created_on_manual" id="created_on_manual" tabindex="8" value="<TMPL_VAR NAME=CREATED_ON_FORMATTED ESCAPE=HTML>" />
<input name="updateSwitch" id="updateSwitch" value="stop" type="button" onclick="switchUpdate()" />
<script type="text/javascript">
<!--
var do_update = false;

function switchUpdate() {
    var obj = document.getElementById("updateSwitch");
    if (do_update) {
        obj.value = "start";
        stopUpdate();
    } else {
        obj.value = "stop";
        startUpdate();
    }
}

function startUpdate() {
    do_update = true;
    updateTime();
}

function stopUpdate() {
    do_update = false;
}

function updateTime() {
    if (do_update) {
        var dd = new Date();
        var _yy = dd.getYear();
        var _mm = dd.getMonth() + 1;
        var _dd = dd.getDate();
        var _HH = dd.getHours();
        var _MM = dd.getMinutes();
        var _SS = dd.getSeconds();

        if (_yy < 2000) { _yy += 1900; }
        if (_mm < 10) { _mm = "0" + _mm; }
        if (_dd < 10) { _dd = "0" + _dd; }
        if (_HH < 10) { _HH = "0" + _HH; }
        if (_MM < 10) { _MM = "0" + _MM; }
        if (_SS < 10) { _SS = "0" + _SS; }

        var obj = document.getElementById("created_on_manual");
        obj.value = _yy + "-" + _mm + "-" + _dd +
          " " + _HH + ":" + _MM + ":" + _SS;

        setTimeout("updateTime()", 1000);
    }
}

function lounchUpdate() {
    var obj = document.getElementById("updateSwitch");
<TMPL_IF NAME=NEW_OBJECT>
    obj.value = "stop";
    startUpdate();
<TMPL_ELSE>
    obj.value = "start";
    stopUpdate();
</TMPL_IF>
}

window.onload = lounchUpdate;

//-->
</script>
HTML
	$$template =~ s/$old/$new/;
}

1;

